import spread_knx as knx
from spread_core.bam.knx.store_interface import KnxWarehouseInterface
from spread_knx.interface import KnxInterface
from . import providers
from ..managers import Manager


class Knx(Manager, KnxWarehouseInterface):
    def __init__(self, p_id, m_id):
        super().__init__(p_id, m_id)
        KnxWarehouseInterface.__init__(self)
        self.dump_topic = None
        self.send_topic = None

    def set_interface(self):
        self.send_interface = KnxInterface(self.mqttc)

    def on_external_command(self, command, response, *args):
        pass

    def on_event(self, event_data: knx.commands.KnxFrame):
        for provider in self.providers_by_address(event_data.address):
            if isinstance(provider, providers.KnxProvider):
                dptu = provider.def_state.empty()
                dptu.fill(event_data.dptu.frame)
                provider.on_request_answer(dptu)
