class Survey:
    def __init__(self, manager):
        self.manager = manager
        self._generator = self.__generator()
        self.status = None
        self.states = None

        self.init_states()
        self.init_status()

    def init_status(self):
        self.status = self.manager.status_survey()

    def init_states(self):
        self.states = self.manager.survey()

    def _next_status(self):
        try:
            while next(self.status):
                continue
        except StopIteration:
            self.init_status()

    def _next_state(self):
        try:
            next(self.states)
        except StopIteration:
            self.init_states()

    def __generator(self):
        while True:
            yield self._next_status()
            yield self._next_state()

    def next(self):
        return next(self._generator)
