import re


def int_float2d(var) -> bool:
    if isinstance(var, int):
        return True
    elif isinstance(var, float):
        if len(str(var).split('.')[1]) < 3:
            return True
    return False


def ip(var: str) -> bool:
    if not isinstance(var, str):
        return False
    arr = var.split('.')
    if len(arr) != 4:
        return False
    for a in arr:
        if not re.match(r'\d+$', a):
            return False
        num = int(a)
        if num < 0 or num > 255:
            return False
    return True


def group_address(var: str):
    if not isinstance(var, str) or var in ('0/0/0', '0/0'):
        return False

    arr = var.split('/')
    for a in arr:
        if not re.match(r'\d+$', a):
            return False

    if len(arr) == 2:
        main = int(arr[0])
        sub = int(arr[1])
        if main < 0 or main > 31:
            return False
        if sub < 0 or sub > 2047:
            return False

    elif len(arr) == 3:
        main = int(arr[0])
        middle = int(arr[1])
        sub = int(arr[2])
        if main < 0 or main > 31:
            return False
        if middle < 0 or middle > 7:
            return False
        if sub < 0 or sub > 255:
            return False

    else:
        return False

    return True


def corr_req_par(p_name: str, p_type: type, struct: dict) -> bool:
    """
    Проверяет правильность обязательного параметра
    т.е. наличие его в структуре и соответствие определенному типу.
    """
    if p_name not in struct:
        return False

    if type(struct[p_name]) == int:
        if p_type not in (int, float):
            return False

    elif type(struct[p_name]) != p_type:
        return False

    return True


def corr_par(p_name: str, p_type: type, struct: dict) -> bool:
    """
    Проверяет правильность необязательного параметра
    т.е. соответствие определенному типу, при наличии его в структуре.
    """
    if p_name in struct:
        if type(struct[p_name]) == int:
            if p_type not in (int, float):
                return False

        elif type(struct[p_name]) != p_type:
            return False

    return True
