ENG_CONSTR = {
    "SwitchingLight": {
        "Simple": {
            "Solid": [
                "DaliRelay",
                "KnxRelay"
            ]
        }
    },
    "DimmingLight": {
        "Simple": {
            "Solid": [
                "DaliDimmer",
                "LomDimmer",
                "KnxDimmer"
            ]
        }
    },
    "RgbLight": {
        "Simple": {
            "Solid": [
                "DaliRgbwaf"
            ]
        },
        "Rgb": {
            "Red": [
                "DaliDimmer",
                "KnxDimmer"
            ],
            "Green": [
                "DaliDimmer",
                "KnxDimmer"
            ],
            "Blue": [
                "DaliDimmer",
                "KnxDimmer"
            ]
        }
    },
    "RgbwLight": {
        "Simple": {
            "Solid": [
                "DaliRgbwaf"
            ]
        },
        "Rgbw": {
            "Red": [
                "DaliDimmer",
                "KnxDimmer"
            ],
            "Green": [
                "DaliDimmer",
                "KnxDimmer"
            ],
            "Blue": [
                "DaliDimmer",
                "KnxDimmer"
            ],
            "White": [
                "DaliDimmer",
                "KnxDimmer"
            ]
        }
    },
    "DynamicLight": {
        "Simple": {
            "Solid": [
                "DaliDimmer",
                "KnxDimmer"
            ]
        }
    },
    "TunableWhiteLight": {
        "Simple": {
            "Solid": [
                "DaliTunableWhite"
            ]
        },
        "Piecemeal": {
            "Cool": [
                "DaliDimmer",
                "KnxDimmer"
            ],
            "Warm": [
                "DaliDimmer",
                "KnxDimmer"
            ]
        }
    },
    "LightSensor": {
        "Simple": {
            "Solid": [
                "DaliLightSensor"
            ]
        },
        "Manageable": {
            "Switch": [
                "DaliRelay",
                "KnxRelay"
            ]
        },
        "Measurable": {
            "Sensor": []
        },
        "Piecemeal": {
            "Switch": [
                "DaliRelay",
                "KnxRelay"
            ],
            "Sensor": []
        }
    },
    "PresenceSensor": {
        "Simple": {
            "Solid": [
                "DaliPresenceSensor"
            ]
        },
        "Manageable": {
            "Switch": [
                "DaliRelay",
                "KnxRelay"
            ]
        },
        "Measurable": {
            "Sensor": []
        },
        "Piecemeal": {
            "Switch": [
                "DaliRelay",
                "KnxRelay"
            ],
            "Sensor": []
        }
    },
    "LightingArea": {
        "Piecemeal": {
            "Actuation[]": [
                "DaliDimmer",
                "DaliRelay",
                "DaliTunableWhite",
                "KnxDimmer"
            ],
            "Luminosity[]": [
                "DaliLightSensor"
            ],
            "Presence[]": [
                "DaliPresenceSensor"
            ],
            "Button[]": [
                "DaliPushButton"
            ]
        }
    },
    "Door": {},
    "Turnstile": {},
    "AudioRenderer": {},
    "VideoRenderer": {},
    "ColdWaterMeter": {},
    "HotWaterMeter": {},
    "WasteWaterMeter": {},
    "Pool": {},
    "TemperatureSensor": {
        "Simple": {
            "Solid": []
        }
    },
    "Thermoregulator": {
        "Simple": {
            "Solid": []
        },
        "Bridge": {
            "Master": [],
            "Slave": []
        }
    },
    "Fan": {
        "Simple": {
            "Solid": [
                "DaliRelay",
                "KnxRelay"
            ]
        }
    },
    "HeatedFloor": {
        "Simple": {
            "Solid": [
                "DaliRelay",
                "KnxRelay"
            ]
        }
    },
    "Stove": {},
    "Camera": {},
    "DoorPhone": {},
    "Panel": {},
    "Scenario": {
        "Simple": {
            "Solid": [
                "DaliRelay",
                "KnxRelay"
            ]
        }
    },
    "PushSensor": {},
    "FireSensor": {
        "Simple": {
            "Solid": [
                "DaliRelay",
                "KnxRelay"
            ]
        }
    },
    "IntruderSensor": {
        "Simple": {
            "Solid": []
        },
        "Trigger": {
            "IsTriggered": [
                "DaliRelay",
                "KnxRelay"
            ]
        },
        "Piecemeal": {
            "IsGuarded": [
                "DaliRelay",
                "KnxRelay"
            ],
            "IsTriggered": [
                "DaliRelay",
                "KnxRelay"
            ]
        }
    },
    "LeakageSensor": {
        "Simple": {
            "Solid": [
                "DaliRelay",
                "KnxRelay"
            ]
        }
    },
    "MotionSensor": {},
    "Screen": {},
    "MeetingRoom": {
        "Simple": {
            "Solid": [
                "EwsRoom"
            ]
        }
    },
    "Workplace": {
        "Simple": {
            "Solid": [
                "EwsEquipment"
            ]
        }
    },
    "Shutter": {
        "Simple": {
            "Solid": []
        }
    },
    "Curtain": {
        "Simple": {
            "Solid": []
        }
    },
    "Blind": {
        "Double": {
            "Closeness": [],
            "Angle": []
        }
    },
    "VentilationUnit": {},
    "InflowDuctFan": {},
    "OutflowDuctFan": {},
    "InflowAirValve": {},
    "OutflowAirValve": {},
    "InflowAirFilter": {},
    "OutflowAirFilter": {},
    "WaterAirHeater": {},
    "WaterAirCooler": {},
    "HeaterWaterPump": {},
    "CoolerWaterPump": {},
    "HeaterWaterValve": {},
    "CoolerWaterValve": {},
    "ElectricAirHeater": {},
    "DuctTemperatureSensor": {},
    "ImmersionTemperatureSensor": {}
}

MAN_PROV_CONSTR = {
    "Dali": [
        "DaliDimmer",
        "DaliRelay",
        "DaliTunableWhite",
        "DaliLightSensor",
        "DaliPresenceSensor",
        "DaliPushButton",
        "DaliRgbwaf"
    ],
    "Mercury": [
        "MercuryElectricMeter"
    ],
    "Lom": [
        "LomDimmer",
        "LomGroup"
    ],
    "Ews": [
        "EwsRoom",
        "EwsEquipment"
    ],
    "Knx": [
        "KnxDimmer",
        "KnxRelay"
    ]
}

SUBG_CONSTR = {
    "Lighting": [
        "SwitchingLight",
        "DimmingLight",
        "RgbLight",
        "RgbwLight",
        "DynamicLight",
        "TunableWhiteLight",
        "LightSensor",
        "PresenceSensor",
        "LightingArea"
    ],
    "Access": [
        "Door",
        "Turnstile"
    ],
    "Multiroom": [
        "AudioRenderer",
        "VideoRenderer"
    ],
    "Water": [
        "ColdWaterMeter",
        "HotWaterMeter",
        "WasteWaterMeter",
        "Pool"
    ],
    "Climate": [
        "TemperatureSensor",
        "Thermoregulator",
        "Fan",
        "HeatedFloor",
        "Stove"
    ],
    "Handling": [
        "Camera",
        "DoorPhone",
        "Panel",
        "Scenario",
        "PushSensor"
    ],
    "Alarm": [
        "FireSensor",
        "IntruderSensor",
        "LeakageSensor",
        "MotionSensor"
    ],
    "Mechanics": [
        "Screen"
    ],
    "Coworking": [
        "MeetingRoom",
        "Workplace"
    ],
    "Shading": [
        "Shutter",
        "Curtain",
        "Blind"
    ],
    "Air": [
        "VentilationUnit",
        "InflowDuctFan",
        "OutflowDuctFan",
        "InflowAirValve",
        "OutflowAirValve",
        "InflowAirFilter",
        "OutflowAirFilter",
        "WaterAirHeater",
        "WaterAirCooler",
        "HeaterWaterPump",
        "CoolerWaterPump",
        "HeaterWaterValve",
        "CoolerWaterValve",
        "ElectricAirHeater",
        "DuctTemperatureSensor",
        "ImmersionTemperatureSensor"
    ]
}
