# import re
from spread_core.bam.validation.base import corr_req_par


class CycleValidator:
    def __init__(self, data):
        if not isinstance(data, dict):
            raise ValueError('Wrong data structure (dict needed)')

        if not corr_req_par('id', int, data) or data['id'] < 1:
            raise ValueError('Wrong id')

        if not corr_req_par('name', str, data):
            raise ValueError('Wrong name')

        if not corr_req_par('period', int, data) or data['period'] < 1:
            raise ValueError('Wrong period')

        if not corr_req_par('duration', float, data) or data['duration'] < 0:
            raise ValueError('Wrong duration')

        if not corr_req_par('startLevel', int, data) or data['startLevel'] < 0 or data['startLevel'] > 100:
            raise ValueError('Wrong startLevel')
