import time
from spread_core.bam.validation.base import corr_req_par


class TriggerValidator:
    def __init__(self, data):
        if not isinstance(data, dict):
            raise ValueError('Wrong data structure (dict needed)')

        if not corr_req_par('id', int, data) or data['id'] < 1:
            raise ValueError('Wrong id')

        if not corr_req_par('day', int, data) or data['day'] < 0:
            raise ValueError('Wrong day')

        if not corr_req_par('time', str, data):
            raise ValueError('Wrong time')
        try:
            time.strptime(data['time'], '%H:%M')
        except:
            raise ValueError('Wrong time')

        if not corr_req_par('level', int, data) or data['level'] < 0 or data['level'] > 100:
            raise ValueError('Wrong level')
