from spread_core.mqtt import jocket, tros3
from spread_core.tests.topics.test_common import TestTopic


class TestTros3Topic(TestTopic):
    def test_invalid(self):
        self.parse_invalid_topic("Tros3")
        self.parse_invalid_topic("Tros3/State")
        self.parse_invalid_topic("Tros3/State/1")
        self.parse_invalid_topic("Tros3/Command/1")

    def test_state(self):
        self.assertEqual(
            tros3.topic.TopicStateTros3(1, jocket.address.EngineryAddress("Enginery", 2, "Funit")),
            self.PARSE("Tros3/State/1/Equipment/Enginery/2/Funit")
        )

    def test_command(self):
        self.assertEqual(
            tros3.topic.TopicCommandTros3(1, jocket.address.EngineryAddress("Enginery", 2, "Funit")),
            self.PARSE("Tros3/Command/1/Equipment/Enginery/2/Funit")
        )
