import os
import sys

if sys.platform == "linux" or sys.platform == "linux2":
    ETC = '/etc'
    VAR = '/var'
else:
    ETC = r'D:\workspace\spread-core\temp\etc'
    VAR = r'D:\workspace\spread-core\temp\var'

# /etc/spread/
CONFIG_PATH =   os.path.join(ETC, 'spread', '')

# /etc/supervisor/conf.d/
SV_PATH =       os.path.join(ETC, 'supervisor', 'conf.d', '')

# /var/log/spread/
LOG_PATH =      os.path.join(VAR, 'log', 'spread', '')

# /var/project/
DUMP_PATH =     os.path.join(VAR, 'project', '')

# /usr/lib/
LIB_PATH =      os.path.join(VAR, 'lib', '')


def build_path(*dest, file='', ext=None):
    _addition_dest, file = os.path.split(file)

    if ext:
        ext = f'{os.path.extsep}{ext}'

        if not file.endswith(ext):
            file = f'{os.path.splitext(file)[0]}{ext}'

    return os.path.join(*map(str, dest), _addition_dest, file)


def DUMP(*dest, file='', ext=None):
    return build_path(DUMP_PATH, *dest, file=file, ext=ext)


def CONFIG(*dest, file='', ext=None):
    return build_path(CONFIG_PATH, *dest, file=file, ext=ext)


def SV(*dest, file='', ext=None):
    return build_path(SV_PATH, *dest, file=file, ext=ext)


def LOG(*dest, file='', ext=None):
    return build_path(LOG_PATH, *dest, file=file, ext=ext)


def LIB(*dest, file='', ext=None):
    return build_path(LIB_PATH, *dest, file=file, ext=ext)


def pid_of_dump(destination: str):
    if destination.startswith(DUMP_PATH):
        try:
            return int(destination.replace(DUMP_PATH, '').split(os.path.sep)[0])
        except (ValueError, IndexError):
            pass

    return None
