# Generated by Django 3.0.10 on 2022-11-21 09:37

from django.db import migrations, models


def set_projector_localpath(apps, _):
    import json
    import os

    projector_conf = '/etc/spread/projector.json'
    projector_local = '/var/project/'

    if os.path.exists(projector_conf):
        with open(projector_conf, 'r') as fs:
            data = json.load(fs)

        if data.get('localPath', None) != projector_local:
            data['localPath'] = projector_local

            with open(projector_conf, 'w') as fs:
                json.dump(data, fs, indent=2)


class Migration(migrations.Migration):

    dependencies = [
        ('spread_dashboard', '0023_climate_and_handling_configs'),
    ]

    operations = [
        migrations.AddField(
            model_name='cycler',
            name='localPath',
            field=models.CharField(default='/var/project/', max_length=255),
        ),
        migrations.AddField(
            model_name='projector',
            name='verifyMode',
            field=models.IntegerField(choices=[(0, 'project_fields_VerifyModeField_0'), (1, 'project_fields_VerifyModeField_1'), (2, 'project_fields_VerifyModeField_2'), (3, 'project_fields_VerifyModeField_3')], default=0, verbose_name='project_fields_VerifyModeField'),
        ),
        migrations.AlterField(
            model_name='projector',
            name='ctpPath',
            field=models.CharField(default='/var/project/throne-project.ctp', max_length=255),
        ),
        migrations.RunPython(set_projector_localpath),
        migrations.AlterField(
            model_name='projector',
            name='localPath',
            field=models.CharField(default='/var/project/', max_length=255),
        ),
        migrations.AlterField(
            model_name='projector',
            name='mosquittoDB',
            field=models.CharField(default='/var/lib/mosquitto/mosquitto.db', max_length=255),
        ),
    ]
